/* */

call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
call SysLoadFuncs

programname='Qu/2'
pipename='\pipe\qu2'

if stream(pipename, 'c', 'open') \= 'READY:' then
    say programname' is not loaded'
else
do
    call lineout pipename, 'info'
    info=linein(pipename)
    if info='' then do
        call lineout pipename, 'filename'
        filename=linein(pipename)
        if filename='' then
            info='silence'
        else
        do
            longname=QueryLongName(filename)
            if longname='' then
                info=substr(filename, lastpos('\', filename)+1)
            else
                info=longname
        end
    end
    call stream pipename, 'c', 'close'
    say programname' is playing 'info
end
return

QueryLongName: procedure
    parse arg filename
    EAT_ASCII='fdff'x  /* The type of '.LONGNAME' EA is ASCII */
    if SysGetEA(filename, '.longname', 'longname')\=0 then
        return ''
    parse var longname type 3 len 5 longname
    if type=EAT_ASCII then
    do
        len=c2d(reverse(len))
        return left(longname, len)
    end
return ''
